;
;
	.text 
	move.l	4(sp), ourbp
;print msg
	lea		msg, a0
	jsr		printit
; get cookie
	pea		get_p_cookies
	move.w	#38,-(sp)
	trap	#14 			;XBIOS Supexec
	addq.l	#6,sp
	move.l	d0,a0
	beq		exit
	
installcookie:
		; cookie is in a0
		clr.l	d0	;RSVF value
		clr.w	d1	;flag
		clr.w	d2	;count cookies
		;look for RSVF
cookieloop0:
		tst.l	(a0)
		beq		cookie_end		; no more cookies
		addq.w	#1,d2
		tst.w	d1
		beq		cookiecmp		;look
		addq.l	#8,a0			;already found, get end
		bra.s	cookieloop0

cookiecmp:
		cmp.l	#$52535666,(a0)		;'RSVf'
		beq		cookiefound2
		cmp.l	#$52535646,(a0)+	;'RSVF'
		beq		cookiefound
		addq.l	#4,a0
		bra.s	cookieloop0

cookiefound:
		move.l	(a0)+,d0		;save value
		move.w	#1,d1			;flag
		bra.s	cookieloop0

cookiefound2:					;rename
		move.l	#$52535646,(a0)	;'RSVf' -> 'RSVF'
		lea		rename_cookie,a0
		bsr.s	printit
		bra.s	exit

cookie_end:
		tst.w	d1
		beq		nocookie	;not installed
		addq.w	#1,d2		;count this one
		move.l	#$52535666,(a0)+	;'RSVf'
		move.l	(a0),d1				;save cnt value
		cmp.l	d1,d2				;space for one mor cookie ?
		blt		cookie_okay
		subq.l	#4,a0			;no
		clr.l	(a0)			;repair null cookie
		lea		smallcookie,a0
		bsr.s	printit
		bra.s	exit
cookie_okay:
		move.l	d0, (a0)+		;RSVF value
		clr.l	(a0)+			;new end cookie
		move.l	d1,(a0);		;value of end cookie
		bra.s	exit

;print msg
nocookie:
	lea		noRSVF, a0
	jsr		printit

exit:
	clr.w	-(sp)	; Pterm0(), exit
	trap	#1


;Supervisor mode
get_p_cookies:
		move.l	$5a0,d0
		rts

printit:
		move.l	a0, -(sp)	;Cconws(d0)
		move.w	#9, -(sp)
		trap	#1
		addq.l	#6,sp
		rts

	.data
ourbp:
	.dc.l	0
msg:
     .DC.b $1b,'p',"RSVF coookie interface Feb 23 1995",$1b,'q',$d,$a
     .DC.b 'v 0.1 (C) jerry g geiger',$d,$a,0

noRSVF:
	.dc.b	"no RSVF cookie",$d,$a,0

smallcookie:
	.dc.b	"no cookies free: can't install RSVf cookie",$d,$a,0
rename_cookie:
	.dc.b	"cookie RSVf renamed to RSVF",$d,$a,0
